"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _reactDom = _interopRequireDefault(require("react-dom"));
var _react = _interopRequireWildcard(require("react"));
var _mergeWith = _interopRequireDefault(require("lodash/mergeWith"));
var _isArray = _interopRequireDefault(require("lodash/isArray"));
var _lowcodeUtils = require("@alilc/lowcode-utils");
var _lowcodeReactRenderer = _interopRequireDefault(require("@alilc/lowcode-react-renderer"));
var _lowcodePluginInject = require("@alilc/lowcode-plugin-inject");
var _appHelper = _interopRequireDefault(require("./appHelper"));
var _mockService = require("./services/mockService");
var _utils = require("./utils");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var SamplePreview = function SamplePreview() {
  var _useState = (0, _react.useState)({}),
    data = _useState[0],
    setData = _useState[1];
  function init() {
    return _init.apply(this, arguments);
  }
  function _init() {
    _init = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var scenarioName, packages, projectSchema, componentsMapArray, componentsTree, i18n, projectDataSource, componentsMap, pageSchema, libraryMap, libraryAsset, vendors, assetLoader, components;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            scenarioName = 'general';
            packages = (0, _mockService.getPackagesFromLocalStorage)(scenarioName);
            projectSchema = (0, _mockService.getProjectSchemaFromLocalStorage)(scenarioName);
            componentsMapArray = projectSchema.componentsMap, componentsTree = projectSchema.componentsTree, i18n = projectSchema.i18n, projectDataSource = projectSchema.dataSource;
            componentsMap = {};
            componentsMapArray.forEach(function (component) {
              componentsMap[component.componentName] = component;
            });
            pageSchema = componentsTree[0];
            libraryMap = {};
            libraryAsset = [];
            packages.forEach(function (_ref2) {
              var _package = _ref2["package"],
                library = _ref2.library,
                urls = _ref2.urls,
                renderUrls = _ref2.renderUrls;
              libraryMap[_package] = library;
              if (renderUrls) {
                libraryAsset.push(renderUrls);
              } else if (urls) {
                libraryAsset.push(urls);
              }
            });
            vendors = [(0, _lowcodeUtils.assetBundle)(libraryAsset, _lowcodeUtils.AssetLevel.Library)]; // TODO asset may cause pollution
            assetLoader = new _lowcodeUtils.AssetLoader();
            _context.next = 14;
            return assetLoader.load(libraryAsset);
          case 14:
            _context.next = 16;
            return (0, _lowcodePluginInject.injectComponents)((0, _lowcodeUtils.buildComponents)(libraryMap, componentsMap));
          case 16:
            components = _context.sent;
            setData({
              schema: pageSchema,
              components: components,
              i18n: i18n,
              projectDataSource: projectDataSource
            });
          case 18:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }));
    return _init.apply(this, arguments);
  }
  var _ref = data,
    schema = _ref.schema,
    components = _ref.components,
    _ref$i18n = _ref.i18n,
    i18n = _ref$i18n === void 0 ? {} : _ref$i18n,
    _ref$projectDataSourc = _ref.projectDataSource,
    projectDataSource = _ref$projectDataSourc === void 0 ? {} : _ref$projectDataSourc;
  if (!schema || !components) {
    init();
    return '';
  }
  var currentLocale = (0, _mockService.getPreviewLocale)(getScenarioName());
  if (!window.setPreviewLocale) {
    // for demo use only, can use this in console to switch language for i18n test
    // 在控制台 window.setPreviewLocale('en-US') 或 window.setPreviewLocale('zh-CN') 查看切换效果
    window.setPreviewLocale = function (locale) {
      return (0, _mockService.setPreviewLocale)(getScenarioName(), locale);
    };
  }
  function customizer(objValue, srcValue) {
    if ((0, _isArray["default"])(objValue)) {
      return objValue.concat(srcValue || []);
    }
  }
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "lowcode-plugin-sample-preview"
  }, /*#__PURE__*/_react["default"].createElement(_lowcodeReactRenderer["default"], {
    className: "lowcode-plugin-sample-preview-content",
    schema: (0, _extends2["default"])({}, schema, {
      dataSource: (0, _mergeWith["default"])(schema.dataSource, projectDataSource, customizer)
    }),
    components: components,
    locale: currentLocale,
    messages: i18n,
    appHelper: _appHelper["default"],
    onCompGetRef: function onCompGetRef(schema, ref) {
      if (schema.componentName === 'FormContainer') {
        (0, _utils.deleteObjectProperty)(schemaRenderRef);
        Object.assign(schemaRenderRef, {
          schema: schema,
          ref: ref
        });
      }
    }
  }));
};
var _default = exports["default"] = SamplePreview;
_reactDom["default"].render( /*#__PURE__*/_react["default"].createElement(SamplePreview, null), document.getElementById('ice-container'));